- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::DenseSymMatrix Class Reference

Class for dense symetrix matrices. More...

`#include <IpDenseSymMatrix.hpp>`

Inheritance diagram for Ipopt::DenseSymMatrix:

[legend]
Collaboration diagram for Ipopt::DenseSymMatrix:

[legend]
List of all members.

## Public Member Functions
SmartPtr< DenseSymMatrix > | MakeNewDenseSymMatrix () const
| Create a new DenseSymMatrix from same MatrixSpace.
Number * | Values ()
| Retrieve the array for storing the matrix elements.
const Number * | Values () const
| Retrieve the array that stores the matrix elements.
void | FillIdentity (Number factor=1.)
| Set this matrix to be a multiple of the identity matrix.
void | AddMatrix (Number alpha, const DenseSymMatrix &A, Number beta)
| Method for adding another matrix to this one.
void | HighRankUpdate (bool trans, Number alpha, const DenseGenMatrix &V, Number beta)
| Method for adding a high-rank update to this matrix.
void | HighRankUpdateTranspose (Number alpha, const MultiVectorMatrix &V1, const MultiVectorMatrix &V2, Number beta)
| Method for adding a high-rank update to this matrix.
void | SpecialAddForLMSR1 (const DenseVector &D, const DenseGenMatrix &L)
| Method for doing a specialized Add operation, required in the limited memory SR1 update.
Constructors / Destructors
| DenseSymMatrix (const DenseSymMatrixSpace *owner_space)
| Constructor, taking the owner_space.
| ~DenseSymMatrix ()
| Destructor.
## Protected Member Functions
Overloaded methods from Matrix base class
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix.
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| DenseSymMatrix ()
| Default Constructor.
| DenseSymMatrix (const DenseSymMatrix &)
| Copy Constructor.
void | operator= (const DenseSymMatrix &)
| Overloaded Equals Operator.
## Private Attributes
const DenseSymMatrixSpace * | owner_space_
| Copy of the owner space ptr as a SymMatrixSpace instead of a MatrixSpace.
Number * | values_
| Array for storing the matrix elements (one columns after each other).
bool | initialized_
| Flag indicating whether the values_ array has been initialized.

## Detailed Description

Class for dense symetrix matrices.

Matrix elements are stored in one array in "Fortran" format, using BLAS "lower triangular" storage (not packed).

Definition at line 31 of file IpDenseSymMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::DenseSymMatrix::DenseSymMatrix | ( | const DenseSymMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

Ipopt::DenseSymMatrix::~DenseSymMatrix | ( |  | ) |

Destructor.

Ipopt::DenseSymMatrix::DenseSymMatrix | ( |  | ) | `[private]`

Default Constructor.

Ipopt::DenseSymMatrix::DenseSymMatrix | ( | const DenseSymMatrix & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

SmartPtr< DenseSymMatrix > Ipopt::DenseSymMatrix::MakeNewDenseSymMatrix | ( |  | ) | const`[inline]`

Create a new DenseSymMatrix from same MatrixSpace.

Definition at line 180 of file IpDenseSymMatrix.hpp.

References Ipopt::DenseSymMatrixSpace::MakeNewDenseSymMatrix(), and owner_space_.

Number* Ipopt::DenseSymMatrix::Values | ( |  | ) | `[inline]`

Retrieve the array for storing the matrix elements.

This is the non-const version, and it is assume that afterwards the calling method will set all matrix elements. The matrix elements are stored one column after each other.

Definition at line 53 of file IpDenseSymMatrix.hpp.

References initialized_, Ipopt::TaggedObject::ObjectChanged(), and values_.

const Number* Ipopt::DenseSymMatrix::Values | ( |  | ) | const`[inline]`

Retrieve the array that stores the matrix elements.

This is the const version, i.e., read-only. The matrix elements are stored one column after each other.

Definition at line 63 of file IpDenseSymMatrix.hpp.

References DBG_ASSERT, initialized_, and values_.

void Ipopt::DenseSymMatrix::FillIdentity | ( | Number | factor = `1.` | ) |

Set this matrix to be a multiple of the identity matrix.

void Ipopt::DenseSymMatrix::AddMatrix | ( | Number | alpha,
|  | const DenseSymMatrix & | A,
|  | Number | beta |
| ) |  |  |

Method for adding another matrix to this one.

If B is this matrix, it becomes B = alpha * A + beta * B after this call.

void Ipopt::DenseSymMatrix::HighRankUpdate | ( | bool | trans,
|  | Number | alpha,
|  | const DenseGenMatrix & | V,
|  | Number | beta |
| ) |  |  |

Method for adding a high-rank update to this matrix.

It computes M = alpha*op(V) op(V)^T + beta*M, where V is a DenseGenMatrix, where op(V) is V^T trans is true.

void Ipopt::DenseSymMatrix::HighRankUpdateTranspose | ( | Number | alpha,
|  | const MultiVectorMatrix & | V1,
|  | const MultiVectorMatrix & | V2,
|  | Number | beta |
| ) |  |  |

Method for adding a high-rank update to this matrix.

It computes M = alpha*V1^T V2 + beta*M, where V1 and V2 are MultiVectorMatrices, so that V1^T V2 is symmetric.

void Ipopt::DenseSymMatrix::SpecialAddForLMSR1 | ( | const DenseVector & | D,
|  | const DenseGenMatrix & | L |
| ) |  |  |

Method for doing a specialized Add operation, required in the limited memory SR1 update.

if M is this matrix, it computes M = M + D + L + L^T, where D is a diagonal matrix (given as a DenseVector), and L is a matrix that is assumed to be strictly lower triangular.

virtual void Ipopt::DenseSymMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::DenseSymMatrix::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::DenseSymMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::DenseSymMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, virtual]`

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::DenseSymMatrix::operator= | ( | const DenseSymMatrix & |  | ) | `[private]`

Overloaded Equals Operator.

## Member Data Documentation

const DenseSymMatrixSpace* Ipopt::DenseSymMatrix::owner_space_`[private]`

Copy of the owner space ptr as a SymMatrixSpace instead of a MatrixSpace.

Reimplemented from Ipopt::SymMatrix.

Definition at line 137 of file IpDenseSymMatrix.hpp.

Referenced by MakeNewDenseSymMatrix().

Number* Ipopt::DenseSymMatrix::values_`[private]`

Array for storing the matrix elements (one columns after each other).

Definition at line 141 of file IpDenseSymMatrix.hpp.

Referenced by Values().

bool Ipopt::DenseSymMatrix::initialized_`[private]`

Flag indicating whether the values_ array has been initialized.

Definition at line 144 of file IpDenseSymMatrix.hpp.

Referenced by Values().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/src/LinAlg/IpDenseSymMatrix.hpp